VERSION 5.00
Begin VB.Form frmMyColorPalette 
   BorderStyle     =   3  'Fixed Dialog
   ClientHeight    =   3105
   ClientLeft      =   2790
   ClientTop       =   4515
   ClientWidth     =   8445
   Icon            =   "MyColorPallete.frx":0000
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3105
   ScaleWidth      =   8445
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox picColorPalette 
      Height          =   1020
      Left            =   180
      ScaleHeight     =   960
      ScaleWidth      =   5895
      TabIndex        =   9
      Top             =   180
      Width           =   5960
   End
   Begin VB.HScrollBar scrlRGB 
      Height          =   270
      Index           =   0
      LargeChange     =   10
      Left            =   900
      Max             =   255
      TabIndex        =   0
      Top             =   1530
      Width           =   2550
   End
   Begin VB.TextBox txtRGB 
      Height          =   285
      Index           =   0
      Left            =   3540
      TabIndex        =   1
      Top             =   1530
      Width           =   480
   End
   Begin VB.HScrollBar scrlRGB 
      Height          =   270
      Index           =   1
      LargeChange     =   10
      Left            =   900
      Max             =   255
      TabIndex        =   2
      Top             =   2010
      Width           =   2550
   End
   Begin VB.TextBox txtRGB 
      Height          =   285
      Index           =   1
      Left            =   3540
      TabIndex        =   3
      Top             =   2010
      Width           =   480
   End
   Begin VB.HScrollBar scrlRGB 
      Height          =   270
      Index           =   2
      LargeChange     =   10
      Left            =   900
      Max             =   255
      TabIndex        =   4
      Top             =   2490
      Width           =   2550
   End
   Begin VB.TextBox txtRGB 
      Height          =   300
      Index           =   2
      Left            =   3540
      TabIndex        =   5
      Top             =   2490
      Width           =   480
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   360
      Left            =   6840
      TabIndex        =   7
      Top             =   690
      Width           =   1455
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   360
      Left            =   6840
      TabIndex        =   6
      Top             =   240
      Width           =   1455
   End
   Begin VB.CommandButton cmdReset 
      Caption         =   "Reset"
      Height          =   360
      Left            =   6840
      TabIndex        =   8
      Top             =   1440
      Width           =   1455
   End
   Begin VB.Label Label7 
      AutoSize        =   -1  'True
      Caption         =   "Basic Colors"
      Height          =   195
      Left            =   180
      TabIndex        =   21
      Top             =   -30
      Width           =   870
   End
   Begin VB.Label lblRGB 
      BorderStyle     =   1  'Fixed Single
      Height          =   285
      Index           =   0
      Left            =   4095
      TabIndex        =   15
      Top             =   1530
      Width           =   585
   End
   Begin VB.Label lblSelectedColor 
      BorderStyle     =   1  'Fixed Single
      Height          =   570
      Left            =   4800
      TabIndex        =   13
      Top             =   1530
      Width           =   1200
   End
   Begin VB.Label lblRGB 
      BorderStyle     =   1  'Fixed Single
      Height          =   285
      Index           =   1
      Left            =   4095
      TabIndex        =   16
      Top             =   2010
      Width           =   585
   End
   Begin VB.Label lblRGB 
      BorderStyle     =   1  'Fixed Single
      Height          =   300
      Index           =   2
      Left            =   4095
      TabIndex        =   17
      Top             =   2490
      Width           =   585
   End
   Begin VB.Label lblNearestSolidColor 
      BorderStyle     =   1  'Fixed Single
      Height          =   570
      Left            =   4800
      TabIndex        =   14
      Top             =   2385
      Width           =   1200
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "RGB Values"
      Height          =   195
      Left            =   3540
      TabIndex        =   20
      Top             =   1320
      Visible         =   0   'False
      Width           =   870
   End
   Begin VB.Label Label5 
      AutoSize        =   -1  'True
      Caption         =   "Selected Color"
      Height          =   195
      Left            =   4800
      TabIndex        =   18
      Top             =   1320
      Width           =   1035
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Red"
      Height          =   195
      Left            =   510
      TabIndex        =   10
      Top             =   1560
      Width           =   300
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Green"
      Height          =   195
      Left            =   375
      TabIndex        =   11
      Top             =   2040
      Width           =   435
   End
   Begin VB.Label Label6 
      AutoSize        =   -1  'True
      Caption         =   "Nearest Solid Color"
      Height          =   195
      Left            =   4800
      TabIndex        =   19
      Top             =   2175
      Width           =   1350
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Blue"
      Height          =   195
      Left            =   495
      TabIndex        =   12
      Top             =   2520
      Width           =   315
   End
End
Attribute VB_Name = "frmMyColorPalette"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub cmdCancel_Click()
Unload Me
End Sub

Private Sub cmdReset_Click()
scrlRGB(0) = 255
scrlRGB(1) = 255 \ 2 ^ 8
scrlRGB(2) = 255 \ 2 ^ 16
End Sub

Private Sub cmdOK_Click()
cmdOK.Caption = ""
Hide
End Sub

Private Sub Display_New_Color_And_Elements(FirstElement, LastElement)
lblSelectedColor.BackColor = rgb(scrlRGB(0), scrlRGB(1), scrlRGB(2))
' Since some of the drawing tools cannot use dithered colors,
' the nearest Solid color to the actual color selected is also displayed.
lblNearestSolidColor.BackColor = GetNearestColor(hdc, lblSelectedColor.BackColor)
For v = FirstElement To LastElement
 txtRGB(v) = Format(scrlRGB(v))
 lblRGB(v).BackColor = scrlRGB(v) * 2 ^ (v * 8)
Next
End Sub

Private Sub Form_Activate()
DrawColorPaletteInPictureBox picColorPalette
End Sub

Private Sub Form_Paint()
Draw3DBorderAroundControl Me, scrlRGB(0), 0, 0, 0, 0, 15, 1
Draw3DBorderAroundControl Me, scrlRGB(1), 0, 0, 0, 0, 15, 1
Draw3DBorderAroundControl Me, scrlRGB(2), 0, 0, 0, 0, 15, 1
Draw3DBorderAroundControl Me, cmdOK, 0, 0, 0, 0, 15, 1
Draw3DBorderAroundControl Me, cmdCancel, 0, 0, 0, 0, 15, 1
Draw3DBorderAroundControl Me, cmdReset, 0, 0, 0, 0, 15, 1
DrawColorPaletteInPictureBox picColorPalette
End Sub

Private Sub picColorPalette_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
' Check if Mouse Coordinates are within the ColorPalette
If X >= 0 And X <= 16 And Y >= 0 And Y <= 3 Then
' Fix(X) + Fix(Y) * 16
End If
End Sub

Private Sub scrlRGB_Change(Index As Integer)
Display_New_Color_And_Elements Index, Index
End Sub

Private Sub scrlRGB_Scroll(Index As Integer)
Display_New_Color_And_Elements Index, Index
End Sub

Private Sub txtRGB_Change(Index As Integer)
If Val(txtRGB(Index)) > 255 Then
 ' A value outside the value RGB range was entered.  Beep
 ' to signal the user, then reset value to previous value
 Beep
 txtRGB(Index) = Format(scrlRGB(Index))
Else
 ' A valid RGB value was entered so reset corresponding RGB Scrollbar
 scrlRGB(Index) = Val(txtRGB(Index))
End If
txtRGB(Index).SelStart = Len(txtRGB(Index))
End Sub

Private Sub txtRGB_KeyPress(Index As Integer, KeyAscii As Integer)
' Do not allow any characters other than 0123456789 to be entered.
If KeyAscii < 48 Or KeyAscii > 57 Then KeyAscii = 0: Beep
End Sub

Sub DrawColorPaletteInPictureBox(PictureBox As Control)
PictureBox.Scale (0, 0)-(16, 3)

'For v = 0 To 15
'16777215
' PictureBox.Line (v, 0)-(v + 1, 1), (255 - v * 17) ^ 2, BF
' PictureBox.Line (v, 1)-(v + 1, 2), (255 - (v + 16) * 17) ^ 2, BF
' PictureBox.Line (v, 2)-(v + 1, 3), (255 - (v + 32) * 17) ^ 2, BF
' PictureBox.Line (v, 0)-(v + 1, 1), 16777215 - (v * 1118481), BF
 'If v Then PictureBox.Line (v, 0)-(v, 3)
'Next
'PictureBox.Scale (0, 0)-(16777215, 3)
'For v = 0 To 16777215 Step 15
' PictureBox.Line (v, 0)-(v, 1), v, BF
'Next
'PictureBox.Scale (0, 0)-(256, 256)
'For v = 0 To 256
 'For w = 0 To 256
 'PictureBox.Line (v, w)-(v + 1, w + 1), rgb(Abs(v - w), Abs(v - w), Abs(v - w)), BF
 'Next
'Next

PictureBox.Scale (0, 0)-(10, 10)

'Dim risfinished As Boolean, gisfinished As Boolean, bisfinished As Boolean
On Error Resume Next
r = 256
g = 256
b = 256
d = 256 / 10
'For v = 0 To 9 '256 To 0 Step -28.44444
 For w = 0 To 10 '256 To 0 Step -28.44444
'  PictureBox.Line (w, v)-(w + 1, v + 1), rgb(r / Fix(v + 1.5), g / Fix(v + 1.5), b / Fix(v + 1.5)), BF
'  r = r - 28.44444 / 9
'  g = g - 28.44444 / 9
'  b = b - 28.44444 / 9
  'PictureBox.Line (w, v)-(w + 1, v + 1), rgb((r - (w + 1) * 28.44444) / (v + 1), (g - (w + 1) * 28.44444) / (v + 1), (b - (w + 1) * 28.44444) / (v + 1)), BF
  'PictureBox.Line (w, v)-(w + 1, v + 1), rgb((r - (w + 1) * 28.44444) - v * 28.44444, (g - (w + 1) * 28.44444) - v * (28.44444 / 2), (b - (w + 1) * 28.44444) - v * (28.44444 / 0.2)), BF
'    PictureBox.Line (w, 0)-(w + 1, 1), rgb((r - (w + 1) * 28.44444) - 0, (g - (w + 1) * 28.44444) - 0, (b - (w + 1) * 28.44444) - 0), BF
  PictureBox.Line (w, 0)-(w + 1, 1), rgb(r - w * 25.6, g - w * 25.6, b - w * 25.6), BF

  PictureBox.Line (w, 1)-(w + 1, 2), rgb(r - w * 25.6 / 3, 0, 0), BF
  PictureBox.Line (w, 2)-(w + 1, 3), rgb(r - w * 25.6 / 3 - r / 3, 0, 0), BF
  PictureBox.Line (w, 3)-(w + 1, 4), rgb(r - w * 25.6 / 3 - r / 3 - 25.6, 0, 0), BF

  PictureBox.Line (w, 4)-(w + 1, 5), rgb(0, g - w * 25.6, 0), BF
  PictureBox.Line (w, 5)-(w + 1, 6), rgb(0, g - w * 25.6, 0), BF
  PictureBox.Line (w, 6)-(w + 1, 7), rgb(0, g - w * 25.6, 0), BF

  PictureBox.Line (w, 7)-(w + 1, 8), rgb(0, 0, b - w * 25.6), BF
  PictureBox.Line (w, 8)-(w + 1, 9), rgb(0, 0, b - w * 25.6), BF
  PictureBox.Line (w, 9)-(w + 1, 10), rgb(0, 0, b - w * 25.6), BF
  '-256/(v+1)
  '23.27273
'  If Not risfinished Then r = r + 28.44444
'  If CInt(r) = 256 Then risfinished = 1

'  If risfinished And Not gisfinished And Not bisfinished Then g = g + 28.44444
'  If CInt(g) = 256 Then gisfinished = 1

'  If risfinished And gisfinished And Not bisfinished Then b = b + 28.44444
'  If CInt(b) = 256 Then bisfinished = 1
 Next
'Next
'PictureBox.Line (0, 1)-(16, 1)
'PictureBox.Line (0, 2)-(16, 2)
End Sub
